#include "HDLC.h "
#include "Sio_poll.h"
#include <stdio.h>     // gets() Testing
#include <stdlib.h>    // malloc(), free()

void hdlc_upcall(unsigned char xdata *packet_ptr);


/*  ͻ
                                                                         
                                    main()                               
                                                                         
                                                                         
                                                                         
    ͼ  */
void main(void)
{ 
    char xdata buf[14];

    init_sio_poll();
    hdlc_init_pca();

    while(1)
    {
        gets(buf, sizeof(buf) - 1);
        printf("\r->%s\r\n", buf);
        tx_send_packet(buf);
    }
}

/*  ͻ
                                                                         
                                  hdlc_upcall()                          
                                                                         
     Saves passed packet and returns asap, freeing rx module             
                                                                         
    ͼ  */
void hdlc_upcall(unsigned char xdata *packet_ptr)
{
    unsigned char i = 1;

    putchar('<');
    putchar('-');

	while((*packet_ptr)--)
	{
        putchar(*(packet_ptr + i++));
	}

    putchar('\r');
    putchar('\n');

    free(packet_ptr);

    return;
}
